extern crate pulldown_cmark;
extern crate regex;
#[macro_use]
extern crate serde_derive;
extern crate toml;

mod logger;
mod error;
mod config_toml;
mod config;
mod template;
mod renderer;
mod builder;

use logger::{LogLevel, Logger};

fn main() {
    let logger = Logger::new(LogLevel::DETAILER);

    match builder::build(&logger) {
        Ok(_) => logger.log(LogLevel::DETAILER, "Building finished successfully."),
        Err(err) => {
            logger.log(err.severity(), err.description());
            logger.log(LogLevel::SEVERE, "Aborting building due to error.");
        }
    }
}
